package tu.kielce.pl.sqlinjectiondemo;

import javafx.scene.control.Alert;
import javafx.scene.control.Button;
import org.springframework.security.crypto.argon2.Argon2PasswordEncoder;

import java.sql.*;

public class LoginManager {
    private final AuthenticationPanel authenticationPanel;
    private final Button loginButton = new Button("Login");
    private final Connection connection;

    public LoginManager(AuthenticationPanel panel, Connection connection) {
        authenticationPanel = panel;
        this.connection = connection;
        loginButton.setPrefSize(290,20);
    }
    private String encodePassword(String password) {
        Argon2PasswordEncoder encoder = new Argon2PasswordEncoder(0,64,1,15*1024,1);
        return encoder.encode(password);
    }
    public void setup() {
        loginButton.setOnAction(actionEvent -> {
            String login = authenticationPanel.getLogin();
            String encodedPassword = encodePassword(authenticationPanel.getPassword());
            try(Statement statement = connection.createStatement()) {
                String selectStatement = new SanitizedQueryProvider(login,encodedPassword).getSelectQuery();
                ResultSet result = statement.executeQuery(selectStatement);
                if(result.next()) {
                    Alert alert = new Alert(Alert.AlertType.CONFIRMATION);
                    alert.setTitle("Authentication");
                    alert.setContentText("Access Granted");
                    alert.show();
                } else {
                    Alert alert = new Alert(Alert.AlertType.ERROR);
                    alert.setTitle("Authentication");
                    alert.setContentText("Access Denied");
                    alert.show();
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }
        });
    }

    /*public void setup() {
        loginButton.setOnAction(actionEvent -> {
            String login = authenticationPanel.getLogin();
            String encodedPassword = encodePassword(authenticationPanel.getPassword());
            String selectStatement = "select * from USERS where name=? and password=?";
            try(PreparedStatement statement = connection.prepareStatement(selectStatement)) {
                statement.setString(1,login);
                statement.setString(2,encodedPassword);
                ResultSet result =  statement.executeQuery();
                if(result.next()) {
                    Alert alert = new Alert(Alert.AlertType.CONFIRMATION);
                    alert.setTitle("Authentication");
                    alert.setContentText("Access Granted");
                    alert.show();
                } else {
                    Alert alert = new Alert(Alert.AlertType.ERROR);
                    alert.setTitle("Authentication");
                    alert.setContentText("Access Denied");
                    alert.show();
                }
            } catch(SQLException e) {
                e.printStackTrace();
            }

        });
    }*/

    public Button getLoginButton() {
        return loginButton;
    }
}
