package tu.kielce.pl.sqlinjectiondemo;

import javafx.scene.control.Button;
import org.springframework.security.crypto.argon2.Argon2PasswordEncoder;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;

public class SignUpManager {
    private final AuthenticationPanel authenticationPanel;
    private final Button signUPButton = new Button("Sign Up");
    private final Connection connection;

    public SignUpManager(AuthenticationPanel panel, Connection connection) {
        authenticationPanel = panel;
        this.connection = connection;
        signUPButton.setPrefSize(290,20);
    }
    private String encodePassword(String password) {
            Argon2PasswordEncoder encoder = new Argon2PasswordEncoder(0,64,1,15*1024,1);
            return encoder.encode(password);
    }

   public void setup() {
        signUPButton.setOnAction(actionEvent -> {
            String login = authenticationPanel.getLogin();
            String encodedPassword = encodePassword(authenticationPanel.getPassword());
            try(Statement statement = connection.createStatement()) {
                String insertStatement = new SanitizedQueryProvider(login, encodedPassword).getInsertQuery();
                statement.execute(insertStatement);
            } catch(SQLException e) {
                e.printStackTrace();
            }
        });
    }
    /*public void setup() {
       signUPButton.setOnAction(actionEvent -> {
            String login = authenticationPanel.getLogin();
            String encodedPassword = encodePassword(authenticationPanel.getPassword());
            String selectStatement = "insert into USERS values (?,?)";
            try(PreparedStatement statement = connection.prepareStatement(selectStatement)) {
                statement.setString(1,login);
                statement.setString(2,encodedPassword);
                statement.execute();
            } catch(SQLException e) {
                e.printStackTrace();
            }

        });
    }*/

    public Button getSignUPButton() {
        return signUPButton;
    }
}
